#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <math.h>


#include "vs56_shm.h"
#include "vs56_comn.h"

extern int set_first_chan;
extern int hist[], imin, imax, hmax;
extern double hmed, havr, hdisp;


void main(int argc, char *argv[]) {
    int i,j, ret, nch, tbeg;
    int first[NumCh], nadd[NumCh], lev[NumCh], e_lev[NumCh];
    double tdelay = 0.1;

init:
    vs56_init();

    for(nch=0; nch<NumCh; nch++) {
      nadd[nch] = lev[nch] = 0;
      e_lev[nch] = tvch[nch]->ref_lev;
    }
    while(1) {
     for(nch=0; nch<NumCh; nch++) {
       if(tvch[nch]->command == INULL) {
	   nadd[nch] = 0;
	   continue;
       }
       if(tvch[nch]->command == IINIT) {
	  tvch[nch]->command = INULL;
	  set_first_chan=1;                    /*force reload*/
	  set_chan(nch, tvch[nch]->next_form);
	  continue;
       }
       if(tvch[nch]->command&IADD) {
	  int add_rd, ccd_rd;
	  int in,fn;

	  if((tvch[nch]->nexp == 0) ||
	     (tvch[nch]->nadd == 0) ) {
	     nadd[nch] = 0;
	     continue;
	  }
	  if (nadd[nch] == 0) {
	     nadd[nch] = tvch[nch]->nadd;
	     first[nch] = 1;
	  }
/*printf("Chan%d com=%d nexp=%d nadd=%d(%d) lev=%d\n",nch,
      tvch[nch]->command,tvch[nch]->nexp,nadd[nch],tvch[nch]->nadd,lev[nch]);*/

	  if(curch!=tvch[nch] ||
	     tvch[nch]->next_form != tvch[nch]->form ||
	     e_lev[nch] != tvch[nch]->ref_lev) {

	     if(e_lev[nch] != tvch[nch]->ref_lev ||
		tvch[nch]->ref_lev != curch->ref_lev) {
		e_lev[nch] = tvch[nch]->ref_lev;
		set_first_chan=1;                    /*force reload*/
	     }
	     set_chan(nch, tvch[nch]->next_form);

	     printf("Chan%d %dx%d format [%d,%d:%d,%d]\n",nch,
	     curch->img_width,curch->img_height, curch->frm_col0,curch->frm_lin0,
	     curch->frm_col0+curch->frm_width, curch->frm_lin0+curch->frm_height);
	  }
	  tbeg = time(0);

	  add_rd = !((curch->command&ICLEAR) && first[nch]);
	  ccd_rd = ((curch->command&ICCD) != 0);

	  if(curch->tandem && curch->exposure > 0.041 ) {
	     ret = inputFrameTandem(curch->exposure);
	  } else {
	     ret = inputFrame56();
	  }
	  if(ret==0) {
	     int lev0 = (add_rd)? lev[nch] : 0;

	     read_frame(add_rd, lev0, ccd_rd);

	     curch->seqn++;
	     curch->tcurr = tbeg;
	     if (add_rd) {
		curch->nadded++;
		curch->addlev += lev0;
	     } else {
		curch->addlev = lev0;
		curch->nadded = 1;
		curch->tstart = tbeg;
	     }
	     sprintf(curch->msg,"Frame%d(%s%d SubLev=%d): Min=%d Max=%d Med=%.1f Avr=%.1f Disp=%.2f",
				 curch->seqn,(add_rd)?"Add":"Get",curch->nadded,curch->addlev,
				 imin, imax, hmed, havr, hdisp);
	     printf("%s\n", curch->msg);
	     lev[nch] = (int)(havr+0.5);
	     curch->seqmsg++;
	  } else {
	     sprintf(curch->msg,"Can't read frame, no video!!!");
	     curch->seqmsg++;
	     fprintf(stderr,"%s\n", curch->msg);
	     nadd[nch] = 0;
	     curch->nadd = 0;
	     curch->nexp = 0;
	  }
	/*printf("Time=%d\n",time(0)-tbeg);*/

	  first[nch] = 0;
	  if (nadd[nch] > 0) nadd[nch]--;

	  in = curch->img_width*curch->img_height;
	  fn = (curch->frm_col0+curch->frm_width)*curch->frm_height;

	  if (nadd[nch] == 0) {
	     if(curch->nexp > 0) curch->nexp--;
	     if(curch->nexp == 0) curch->command &= ~IEXP;
	     else {
		tdelay = 0.3*(double)fn/(double)in;
		if (tdelay<0.02) tdelay=0.02;
	     }
	  } else {
	     double k = (double)fn/(double)in;
	     tdelay = 0.2*k*k;
	     if (tdelay<0.02) {
		int n = (int)(0.02/tdelay + 0.5);
		if (n>20) n=20;
		if(curch->nadded % n == 0)
		   tdelay=0.02;
		else
		   tdelay=0.0;
	     }
	  }
       }
       else if(tvch[nch]->command&ICLEAR) {
	  ushort *p;
	  for(p=curch->image,j=0; j<MaxWidth*MaxHeight; j++) *p++ = 0;
	  nadd[nch] = 0;
	  first[nch] = 1;
	  tvch[nch]->seqn++;
	  tvch[nch]->command &= ~ICLEAR;
       }
       if((tvch[nch]->command&IWRITE) && (ver_board_56>1)) {
	  if(curch!=tvch[nch])
	     set_chan(nch, tvch[nch]->next_form);
	  write_image();
	  curch->command &= ~IWRITE;
       }
     }
/*if (tdelay!=0.1) printf("Delay=%.2f\n",tdelay);*/
     if (tdelay>=0.01)
	mydelay(tdelay);
     tdelay = 0.1;
    }
  /*
   * for(i=0;i<25;i++) {
   *    printf("%03d: ",i*10);
   *    for(j=0;j<10;j++)
   *       printf(" %6d",hist[i*10+j]);
   *    printf("\n");
   * }
   */
    vs56_exit(0);
}

