#define NumCh     4
#define MaxWidth  768
#define MaxHeight 576

/* commands */
#define INULL     0    /* nothing to do */
#define ICLEAR    1    /* clear image before exposure */
#define IADD      2    /* do exposure and add it to image */
#define IEXP      (ICLEAR|IADD)  /* do exposure */
#define ICCD      4    /* read image with online CCD "line-reduction" */
#define IWRITE    8    /* write low bytes of image back to vs56/2 */
#define IINIT     16   /* re-intializate vs56 */

struct TVchan {
   int num;         /* OUT channel number */
   int tandem;      /* OUT "Tandem" chan. flag */
   double exposure; /* IN  sec, for "Tandem" only! */
   int activ;       /* OUT last set_chan(this_channel,) */
   int seqn;        /* OUT sequential number of current image */
   int tstart;      /* OUT time() of 1-st ADDed image */
   int tcurr;       /* OUT time() of last ADDed (current) image */
   int command;     /* IN  actions to do (CLEAR,EXP,ADD and so on) */
   int nexp;        /* IN  number of times to execute command (-1 - infinit)*/
   int nadd;        /* IN  number of images to ADD (-1 - infinit)*/
   int nadded;      /* OUT number of images really  ADDed */
   int addlev;      /* OUT zero level already substructed from ADDed images */
   int next_form;   /* IN  to change format (1-768x576, 2-512x512) */
   int form;        /* OUT current format */
   int ref_lev;     /* IN  electric reference level (0-63) */
   int img_width;   /* OUT image sizes for current format */
   int img_height;  /* OUT */
   int frm_width;   /* IN  frame size */
   int frm_height;  /* IN  */
   int frm_col0;    /* IN  frame position */
   int frm_lin0;    /* IN  */
   int seqmsg;      /* OUT number of last message */
   char msg[100];   /* OUT last message buffer */
   int bias;           /* IN CCD bias level */
   int flat[MaxWidth]; /* IN CCD "Line" FlatField <<8 */
   short image[MaxWidth*MaxHeight];/* OUT image itself */
};

extern struct TVchan *tvch[NumCh], *curch;
